View this project on [CADLAB.io](https://cadlab.io/project/27502). 

# WOBC

WOBCは，WASAロケットプロジェクトにおける電装関連の共通基盤を確立することを目的としたプロジェクトである．
開発した回路や基板の設計情報，プログラムといった資産を再利用しやすい形で整備することで，
開発スピードを向上させるとともに引き継ぎや教育を効率的に行えるようにする．

# 用語

## ユニット

単独で動作する，システムの基本単位．例：ロケット電装，CanSat電装，地上局

1つ以上のモジュールから構成される．

## モジュール

コンポーネントを一枚の基板上に配置した，物理的な単位．例：地上局モジュール，通信モジュール

モジュールには必ずマイコンが含まれ，コンポーネントを制御する．
ユニットを構成するモジュール間はバスで接続される．

## コンポーネント

ユニットを構成する，意味のある一つの機能単位．例：電源管理，姿勢決定，モーター駆動

ハードウェアおよびプログラムはコンポーネント単位で開発する．

## パケット

ユニットやコンポーネント間でやり取りするデータの形式．
詳しくは[WCPP](https://github.com/wasa-rockoon/WCPP)を参照．


# 開発

モジュールやコンポーネントは，全てこのリポジトリに格納する（Monorepoスタイル）．

## Gitの運用

- 開発者ごとに，`develop/your_name` ブランチを作成する．
- 全体に反映したい変更ができたらPull Requestを作成し，責任者にレビューを依頼する．
- 責任者は変更をレビューし，問題なければ`main`ブランチにマージする．（回路・基板のレビューには[CADLAB.io](https://cadlab.io/project/27502)を使うと便利)



# ドキュメント

- [develop](docs/develop.md): 詳細な開発の手順
- [kicad](docs/kicad.md): KiCADを用いた回路・基板設計マニュアル
- [components](docs/components): コンポーネントとその機能，インターフェースの一覧
